<template>
  <ob-modal
      ref="baseTarif"
      title="Базовая цена"
      size="large"
      custom-class="modal-small"
      :is-show-pagination="false"
      :is-show-controls="true"
      @submit="saveRate"
      @closed="$emit('closed')"
      :is-submit-disabled="submitDisabled"
  >
    <modal-content
        :data="data"
        :distance="distance"
        :fixedPriceStage="formData.price_stage"
        :fixedPrice="formData.price_km"
        :fixedPriceDistance ="formData.fixedPriceDistance"
        :fixedPriceAvailability="formData.fixedPriceAvailability"
        :is-submit-disabled="additionalActionDisabled"
        @fieldChanged="updateFormDataField"
        @recalculateBasePrice="recalculateBasePrice"
    />
  </ob-modal>
</template>
<script>
  import api from '@/api';
  import ObModal from 'common-components/src/obComponents/obModal';
  import ModalContent from './ModalContent';

  export default {
    name: 'BasePriceModal',
    components: {
      ObModal,
      ModalContent,
    },
    props: {
      data: {
        type: Object,
        default: () => {},
      },
      departureUuid: String,
      arrivalUuid: String,
    },
    computed: {
      fixedTotal() {
        return this.distance * this.formData.price_km;
      },
      submitDisabled() {
        return (
          ( (this.initFormData.price_stage == this.formData.price_stage &&
            this.initFormData.fixedPriceAvailability ==
            this.formData.fixedPriceAvailability &&
            this.initFormData.fixedPriceDistance ==
            this.formData.fixedPriceDistance) ||
            !this.formData.price_stage || !this.formData.fixedPriceDistance) && !this.data['fixed_price']?.fixedPriceIsEdit
        );
      },
    },
    data() {
      return {
        test: true,
        distance: null,
        additionalActionDisabled: true,
        initialFixedPriceAvailability: false,
        initFormData: {
          price_stage: null,
          price_km: null,
          fixedPriceDistance: null,
          fixedPriceAvailability: false,
        },
        formData: {
          price_stage: null,
          price_km: null,
          fixedPriceDistance: null,
          fixedPriceAvailability: false,
        },
      };
    },
    methods: {
      async open() {
        await this.getModalData();

        const recalculateStatus = await api.base_prices.getRecalculateStatus();
        if(!recalculateStatus.execute){
          this.additionalActionDisabled = false
        }

        this.$nextTick(() => {
          this.$refs.baseTarif.open();
        });
      },
      getModalData() {
        // Приоритетность дистанций:
        // 1. Fixed price
        // 2. Base price
        // 3. Expert price
        // 4. Екстраполяция
        const ratePriority = ['fixed_price', 'base_price', 'expert_price'];
        const result = ratePriority
          .map(rateName => ({
            rateName,
            ...this.data[rateName],
          }))
          .find(resourceData => !!(resourceData || {}).distance);

        const { distance, price_km, price_stage } = this.data['fixed_price'] || {};



        this.initFormData.price_km = this.formData.price_km = price_km;
        this.initFormData.fixedPriceDistance = this.formData.fixedPriceDistance = distance || result?.distance;
        this.initFormData.price_stage = this.formData.price_stage = price_stage;
        this.initFormData.fixedPriceAvailability = this.formData.fixedPriceAvailability =
          (!!price_km && this.data.is_fixed_price_currently) || this.data['fixed_price']?.fixedPriceIsEdit;
        const basePriceDistance = this.data['base_price']?.distance;

        if (!basePriceDistance || !this.initFormData.fixedPriceDistance) {
          this.getExtrapolateDistance();
        }
        basePriceDistance ? this.distance = basePriceDistance: null;
      },
      async getExtrapolateDistance() {
        try {
          const { distance } = await api.base_prices.getExtrapolationDistance(
            this.departureUuid,
            this.arrivalUuid,
            this.data.resource_uuid
          );
          !this.distance? this.distance = distance: null;
          !this.initFormData.fixedPriceDistance? this.formData.fixedPriceDistance = distance: null;
        } catch {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных',
          });
        }
      },
      updateFormDataField(name, value) {
        this.formData[name] = value;
      },
      async saveRate() {
        if (
          this.initFormData.fixedPriceAvailability &&
          !this.formData.fixedPriceAvailability
        ) {
          this.deleteFixedPrice();
        } else {
          this.updateFixedPrice();
        }
      },
      async updateFixedPrice() {
        let notificationId = new Date().getTime() + 'save';
        try {
          this.$notification({
            type: 'system_notification_in_load',
            message: 'Сохранение',
            id: notificationId,
          });
          await api.base_prices.updateFixedPrice(
            this.departureUuid,
            this.arrivalUuid,
            this.data.resource_uuid,
            {
              price_stage: this.formData.price_stage,
              distance: this.formData.fixedPriceDistance,
            }
          );
          this.$notification({
            type: 'system_notification_success',
            message: `Сохранено`,
          });
          this.$emit('updated');
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Не сохранено',
          });
        } finally {
          this.$notification({ event: 'close', id: notificationId });
        }
        this.$refs.baseTarif.close();
      },
      async deleteFixedPrice() {
        let notificationId = new Date().getTime() + 'save';
        try {
          this.$notification({
            type: 'system_notification_in_load',
            message: 'Сохранение',
            id: notificationId,
          });

          await api.base_prices.deleteFixedPrice(
            this.departureUuid,
            this.arrivalUuid,
            this.data.resource_uuid
          );

          this.$notification({
            type: 'system_notification_success',
            message: `Сохранено`,
          });
          this.$emit('updated');
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Не сохранено',
          });
        } finally {
          this.$notification({ event: 'close', id: notificationId });
        }
        this.$refs.baseTarif.close();
      },
      async recalculateBasePrice() {
        await api.base_prices.recalculateTariffBasePrice(this.data.uuid);
        this.$refs.baseTarif.close();
        this.$emit('updated');
      }
    },
  };
</script>
